<?php
class THEGLOBALlist extends WP_Widget {
	function THEGLOBALlist() {
		$widget_ops = array('classname' => 'widget_THEGLOBALlist', 'description' => __('(Sidebar Only) - List posts from any or all of your categories'));
		$this->WP_Widget('THEGLOBALlist', __('The Global: Post List'), $widget_ops, $control_ops);
	}
	function widget($args, $instance) {
		global $post;
		$post_old = $post; 
		extract( $args );
	if( !$instance["title"] ) {
		$category_info = get_category($instance["cat"]);
		$instance["title"] = $category_info->name;
	}
	echo $before_widget;

	echo $before_title;			
	if( $instance["title_link"] )
		echo '<a href="' . get_category_link($instance["cat"]) . '">' . $instance["title"] . '</a>';
	else
		echo '' . $instance["title"] . '';
	echo $after_title;

?>
<ul>
	<?php if( $instance["latest"] ) { ?>
		<?php $my_query = new WP_Query("showposts=" . $instance["show"] . "&offset=" . $instance["skip"]); ?>
	<?php } else { ?>
		<?php $my_query = new WP_Query("cat=" . $instance["cat"] . "&showposts=" . $instance["show"] . "&offset=" . $instance["skip"]); ?>
	<?php } ?>
	<?php while ($my_query->have_posts()) : $my_query->the_post(); ?>
		<li><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></li>
	<?php endwhile; ?>
</ul>
<?php
	echo $after_widget;
	$post = $post_old; 
}
function update($new_instance, $old_instance) {
	return $new_instance;
}
function form($instance) {
?>
<p><b>Useage:</b></p>
<p>This widget is only suitable for use within any of the <b>Sidebar</b> widgetised areas.</p>
<p><div style="clear: both; padding-bottom: 5px; margin-bottom: 15px; border-bottom: 1px solid #efefef;"></div></p>
<p><b>Title:</b></p>
<p>
	<label for="<?php echo $this->get_field_id("title"); ?>">
		<?php _e( 'Widget title:' ); ?>
		<input class="widefat" id="<?php echo $this->get_field_id("title"); ?>" name="<?php echo $this->get_field_name("title"); ?>" type="text" value="<?php echo esc_attr($instance["title"]); ?>" />
	</label>
</p>		
<p>
	<label for="<?php echo $this->get_field_id("title_link"); ?>">
		<?php _e( 'Link it to category?' ); ?>
		<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id("title_link"); ?>" name="<?php echo $this->get_field_name("title_link"); ?>"<?php checked( (bool) $instance["title_link"], true ); ?> />
	</label>
</p>
<p><div style="clear: both; padding-bottom: 5px; margin-bottom: 15px; border-bottom: 1px solid #efefef;"></div></p>
<p><b>Contents:</b></p>
<p>
	<label for="<?php echo $this->get_field_id("latest"); ?>">
		<?php _e( 'All categories?' ); ?>
		<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id("latest"); ?>" name="<?php echo $this->get_field_name("latest"); ?>"<?php checked( (bool) $instance["latest"], true ); ?> />
	</label>
</p>
<p>
	<label>
		<label for="<?php echo $this->get_field_id("cat"); ?>">
		<?php _e( 'Category:' ); ?>		
		<?php wp_dropdown_categories( array( 'name' => $this->get_field_name("cat"), 'selected' => $instance["cat"] ) ); ?>
	</label>
</p>
<p><div style="clear: both; padding-bottom: 5px; margin-bottom: 15px; border-bottom: 1px solid #efefef;"></div></p>
<p><b>Options:</b></p>		
<p>
	<label for="<?php echo $this->get_field_id("show"); ?>">
		<?php _e( 'Post Count:' ); ?>
		<input style="text-align: center;" id="<?php echo $this->get_field_id("show"); ?>" name="<?php echo $this->get_field_name("show"); ?>" type="text" value="<?php echo absint($instance["show"]); ?>" size='3' />
	</label>
</p>
<p>
	<label for="<?php echo $this->get_field_id("skip"); ?>">
		<?php _e( 'Skip Posts:' ); ?>
		<input style="text-align: center;" id="<?php echo $this->get_field_id("skip"); ?>" name="<?php echo $this->get_field_name("skip"); ?>" type="text" value="<?php echo absint($instance["skip"]); ?>" size='3' />
	</label>
</p>
<p><div style="clear: both; padding-bottom: 5px; margin-bottom: 15px; border-bottom: 1px solid #efefef;"></div></p>
<?php
	}
	}
add_action( 'widgets_init', create_function('', 'return register_widget("THEGLOBALlist");') );
?>